Loading...
Searching...
No Matches
gtsam::GraphvizFormatting Struct Reference

## Detailed Description

Formatting options and functions for saving a NonlinearFactorGraph instance in GraphViz format.

Inheritance diagram for gtsam::GraphvizFormatting:

## Public Member Functions

| GraphvizFormatting ()
| Default constructor sets up robot coordinates.
Vector2 | findBounds (const Values &values, const KeySet &keys) const
boost::optional< Vector2 > | extractPosition (const Value &value) const
| Extract a Vector2 from either Vector2, Pose2, Pose3, or Point3.
boost::optional< Vector2 > | variablePos (const Values &values, const Vector2 &min, Key key) const
| Return affinely transformed variable position if it exists.
boost::optional< Vector2 > | factorPos (const Vector2 &min, size_t i) const
| Return affinely transformed factor position if it exists.
Public Member Functions inherited from gtsam::DotWriter
| DotWriter (double figureWidthInches=5, double figureHeightInches=5, bool plotFactorPoints=true, bool connectKeysToFactor=true, bool binaryEdges=false)
void | graphPreamble (std::ostream *os) const
| Write out preamble for graph, including size.
void | digraphPreamble (std::ostream *os) const
| Write out preamble for digraph, including size.
void | drawVariable (Key key, const KeyFormatter &keyFormatter, const boost::optional< Vector2 > &position, std::ostream *os) const
| Create a variable dot fragment.
boost::optional< Vector2 > | variablePos (Key key) const
| Return variable position or none.
void | processFactor (size_t i, const KeyVector &keys, const KeyFormatter &keyFormatter, const boost::optional< Vector2 > &position, std::ostream *os) const
| Draw a single factor, specified by its index i and its variable keys.

## Public Attributes

Axis | paperHorizontalAxis
| The world axis assigned to the horizontal paper axis.
Axis | paperVerticalAxis
| The world axis assigned to the vertical paper axis.
double | scale
| Scale all positions to reduce / increase density.
bool | mergeSimilarFactors
| Merge multiple factors that have the same connectivity.
Public Attributes inherited from gtsam::DotWriter
double | figureWidthInches
| The figure width on paper in inches.
double | figureHeightInches
| The figure height on paper in inches.
bool | plotFactorPoints
| Plots each factor as a dot between the variables.
bool | connectKeysToFactor
| Draw a line from each key within a factor to the dot of the factor.
bool | binaryEdges
| just use non-dotted edges for binary factors
std::map< Key, Vector2 > | variablePositions
| Variable positions can be optionally specified and will be included in the dot file with a "!' sign, so "neato" can use it to render them.
std::map< char, double > | positionHints
| The position hints allow one to use symbol character and index to specify position.
std::set< Key > | boxes
| A set of keys that will be displayed as a box.
std::map< size_t, Vector2 > | factorPositions
| Factor positions can be optionally specified and will be included in the dot file with a "!' sign, so "neato" can use it to render them.

## Public Types

enum | Axis { X , Y , Z , NEGX , NEGY , NEGZ }
| World axes to be assigned to paper axes.

## Additional Inherited Members

Static Public Member Functions inherited from gtsam::DotWriter
static void | DrawFactor (size_t i, const boost::optional< Vector2 > &position, std::ostream *os)
| Create factor dot.

## Constructor & Destructor Documentation

## GraphvizFormatting()

gtsam::GraphvizFormatting::GraphvizFormatting | ( |  | ) |

inline

Default constructor sets up robot coordinates.

Paper horizontal is robot Y, paper vertical is robot X. Default figure size of 5x5 in.

The documentation for this struct was generated from the following files:

- /build/gtsam-RkN8wG/gtsam-4.2.2+dfsg/gtsam/nonlinear/GraphvizFormatting.h
- /build/gtsam-RkN8wG/gtsam-4.2.2+dfsg/gtsam/nonlinear/GraphvizFormatting.cpp